package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesCraft;
import io.swagger.annotations.ApiOperation;

/**
 * @Description : 工艺信息
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/11 13:54
 * @Modify:
 **/
public interface IMesCraftService extends IBaseMesService<MesCraft> {

    @ApiOperation("根据工艺流程代码查询工艺")
    ListPager<MesCraft> findMesCraft(MesCraft mesCraft, Pager pager);
}
