package cn.estsh.i3plus.ext.mes.api.base;


import cn.estsh.i3plus.pojo.mes.bean.shipping.MesCustSortInfo;

import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/2 20:38
 * @Modify:
 **/
public interface IMesCustSoftInfoService extends IBaseMesService<MesCustSortInfo> {
    /**
     * 获取客户排序信息
     * @param custCode
     * @param custOrganizeCode
     * @param infoPointCode
     * @param organizeCode
     * @param custPartNoList
     * @return
     */
    List<MesCustSortInfo> queryCustSortInfoList(String custCode,String custOrganizeCode,String infoPointCode,String organizeCode,List<String> custPartNoList);

    /**
     * 更新custSortInfo
     * @param custSortInfo
     */
    void updateCustSortInfo(MesCustSortInfo custSortInfo);
}
