package cn.estsh.i3plus.ext.mes.api.base;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesProductPlan;
import io.swagger.annotations.ApiOperation;

/**
 * @Description : SAP生产计划
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/6 15:52
 * @Modify:
 **/
public interface IMesProductPlanService extends IBaseMesService<MesProductPlan> {

    @ApiOperation(value = "分页查询SAP生产计划", notes = "分页查询SAP生产计划")
    ListPager<MesProductPlan> queryMesProductPlanPager(MesProductPlan mesProductPlan, Pager pager);

}
