package cn.estsh.i3plus.ext.mes.api.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.MesEquipment;
import cn.estsh.i3plus.pojo.mes.model.MesEquipmentModel;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : mes设备管理
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-08-26
 * @Modify:
 **/
public interface IEquipmentExtService {
    

    /**
     * 按条件分页查询mes设备台账-组织模型
     *
     * @param equipment 设备台账
     * @param pager     分页条件
     * @return 数据集合
     */
    @ApiOperation(value = "按条件分页查询mes设备台账-组织模型")
    ListPager queryMesEquipmentByPagerOrg(MesEquipment equipment, Pager pager);
    
}
