package cn.estsh.i3plus.ext.mes.apiservice.dao;

import cn.estsh.i3plus.ext.mes.pojo.model.MesLoadingListDetailModel;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.mes.bean.shipping.MesLoadingListDetail;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : SAP生产计划
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/7 15:13
 * @Modify:
 **/
public interface IMesLoadingListDetailDao {

    @ApiOperation(value = "分页查询装车单明细", notes = "分页查询装车单明细")
    List<MesLoadingListDetailModel> queryLoadingListDetailModel(MesLoadingListDetail detail, Pager pager);

    @ApiOperation(value = "分页查询装车单明细", notes = "分页查询装车单明细")
    int queryLoadingListDetailModelCount(MesLoadingListDetail detail);
}
