package cn.estsh.i3plus.ext.mes.apiservice.dbinterface;

/**
 * @Description : 脚本引擎中可以实现的方法
 * @Reference :
 * @Author : rock.yu
 * @CreateDate : 2019-10-14 19:14
 * @Modify:
 * 1.
 **/
public class WmsSAPDbConstWords {

    // 脚本读取数据的方法名，入参：WmsInterfaceDataMapper 返回值： List<Map<String, Object>>
    public static final String SCRIPT_PULL_FUN_NAME = "readData";
    // 脚本写入目标数据的方法名，入参：WmsInterfaceDataMapper，List<Map<String, Object>> 返回值：void
    public static final String SCRIPT_PUSH_FUN_NAME = "saveDestData";
    // 脚本更新来源数据标志的方法名，入参：WmsInterfaceDataMapper，List<Map<String, Object>> 返回值：void
    public static final String SCRIPT_MARK_FUN_NAME = "saveSrcData";
    // 脚本过滤来源数据的方法名，入参： List<Map<String, Object>> 返回值：List<Map<String, Object>>
    public static final String SCRIPT_FILTER_FUN_NAME = "filterData";
}
