package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesCavityGroupDetailCfgService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesCavityGroupCfg;
import cn.estsh.i3plus.pojo.mes.bean.MesCavityGroupDetailCfg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description : 腔组明细维护
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/14 14:05
 * @Modify:
 **/
@Service
@Slf4j
public class MesCavityGroupDetailCfgServiceImpl extends BaseMesService<MesCavityGroupDetailCfg> implements IMesCavityGroupDetailCfgService {

    @Override
    protected void setPackQueryBean(MesCavityGroupDetailCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getCavityCode(),"cavityCode",packBean);
        DdlPreparedPack.getStringEqualPack(bean.getEquipmentCode(),"equipmentCode",packBean);
    }


    @Override
    protected void onInsertBean(MesCavityGroupDetailCfg item) {

    }

    @Override
    protected void onUpdateBean(MesCavityGroupDetailCfg item) {
    }
}
