package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesErpWorkCenterService;
import cn.estsh.i3plus.ext.mes.api.base.IMesPartPullService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesErpWorkCenter;
import cn.estsh.i3plus.pojo.mes.bean.MesPartPull;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesErpWorkCenterService extends BaseMesService<MesErpWorkCenter> implements IMesErpWorkCenterService {

    protected void setPackQueryBean(MesErpWorkCenter bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getErpWorkCenterCode(), "erpWorkCenterCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getErpWorkCenterName(), "erpWorkCenterName", packBean);
    }
}
