package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesMaximoMeterMainDataService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesMaximoMeterMainData;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


/**
 * @Description : Maximo仪表主数据
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/5/17 10:06
 * @Modify:
 **/
@Service
@Slf4j
public class MesMaximoMeterMainDataServiceImpl extends BaseMesService<MesMaximoMeterMainData> implements IMesMaximoMeterMainDataService {

    @Override
    protected void setPackQueryBean(MesMaximoMeterMainData bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getAssetNum(), "assetNum", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getBaseMeasureUnitId(), "baseMeasureUnitId", packBean);
        DdlPreparedPack.getStringEqualPack(bean.getMeterName(), "meterName", packBean);
    }

}
