package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesMediaFileCfgService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesMediaFileCfg;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
/**
 * @Description: 媒体文件维护
 * @CreateDate 2024/6/6
 * @Author gsz
 */
@Service
@Slf4j
public class MesMediaFileCfgService extends BaseMesService<MesMediaFileCfg> implements IMesMediaFileCfgService {

    protected void setPackQueryBean(MesMediaFileCfg bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getFileName(), "fileName", packBean);
        DdlPreparedPack.getNumEqualPack(bean.getFileType(), "fileType", packBean);
    }
}
