package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.webservice;

import cn.estsh.i3plus.ext.mes.apiservice.model.MeterInfo;
import cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.busi.MaximoServiceImpl;
import cn.estsh.i3plus.ext.mes.pojo.model.MaximoParamModel;
import cn.estsh.impp.framework.boot.util.SpringContextsUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import java.util.Map;

@WebService(targetNamespace = "http://yfaiesb/services/ServiceSyncMaximoInstrument")
public class WebServiceServerIns {
    public static final Logger LOGGER = LoggerFactory.getLogger(WebServiceServerIns.class);

    @WebMethod(action = "SyncMaximoInstrument", operationName = "SyncMaximoInstrument")
    public Map syncInstrument(@WebParam(name = "info") MeterInfo meterInfo) {
        LOGGER.info("syncInstrument主数据:{}", meterInfo);
        MaximoParamModel maximoParamModel = new MaximoParamModel();
        maximoParamModel.setAssetNum(meterInfo.getASSETNUM());
        maximoParamModel.setBaseMeasureUnitId(meterInfo.getBASEMEASUREUNITID());
        maximoParamModel.setMeterName(meterInfo.getMETERNAME());
        maximoParamModel.setSiteId(meterInfo.getSITEID());
        MaximoServiceImpl bean = (MaximoServiceImpl) SpringContextsUtil.getBean("maximoServiceImpl");
        return bean.doMeterMainData(maximoParamModel);
    }

}
