package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesMouldMultiCavityService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesMouldMultiCavity;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
/**
 * @Description : 一模多腔维护
 * @Reference :
 * @Author : junsheng.li
 * @CreateDate 2024/5/14 14:29
 * @Modify:
 **/
@Service
@Slf4j
public class MesMouldMultiCavityServiceImpl extends BaseMesService<MesMouldMultiCavity> implements IMesMouldMultiCavityService {
    @Override
    protected void setPackQueryBean(MesMouldMultiCavity bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringEqualPack(bean.getMouldNo(),"mouldNo",packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPartNo(),"partNo",packBean);
        DdlPreparedPack.getStringEqualPack(bean.getEquipmentCode(),"equipmentCode",packBean);
    }
    @Override
    protected void onInsertBean(MesMouldMultiCavity item) {

    }

    @Override
    protected void onUpdateBean(MesMouldMultiCavity item) {
    }
}
