package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesPartPullService;
import cn.estsh.i3plus.ext.mes.api.base.IMesPartTypeService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPartPull;
import cn.estsh.i3plus.pojo.mes.bean.MesPartType;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

@Service
@Slf4j
public class MesPartPullService extends BaseMesService<MesPartPull> implements IMesPartPullService {

    protected void setPackQueryBean(MesPartPull bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getPullCode(), "pullCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPullName(), "pullName", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getWorkCenterCode(), "workCenterCode", packBean);
    }
}
