package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.base;

import cn.estsh.i3plus.ext.mes.api.base.IMesProduceGroupService;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesProduceGroup;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

/**
 * @Description : MES_生产组
 * @Reference :
 * @Author : gsz
 * @CreateDate 2024/6/9 13:30
 * @Modify:
 **/
@Service
@Slf4j
public class MesProduceGroupServiceImpl extends BaseMesService<MesProduceGroup> implements IMesProduceGroupService {

    @Override
    protected void setPackQueryBean(MesProduceGroup bean, DdlPackBean packBean) {
        DdlPreparedPack.getStringLikerPack(bean.getPgCode(), "pgCode", packBean);
        DdlPreparedPack.getStringLikerPack(bean.getPgName(), "pgName", packBean);
    }

}
