package cn.estsh.i3plus.ext.mes.pojo.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiParam;
import lombok.Data;

/**
 * @author gsz
 * @description
 * @date 2024/5/15 13:53
 */
@Data
@ApiModel("maximo主数据参数")
public class MaximoParamModel {
    private static final long serialVersionUID = 4235227045174076286L;

    @ApiParam(value = "仪表编号")
    private String meterName;

    @ApiParam(value = "设备编号")
    private String assetNum;

    @ApiParam(value = "设备名称")
    private String description;

    @ApiParam(value = "计量单位")
    private String baseMeasureUnitId;

    @ApiParam(value = "工厂")
    private String siteId;

    @ApiParam(value = "状态")
    private String status;

    @ApiParam(value = "故障类别")
    private String failureCode;

}
