package cn.estsh.i3plus.ext.mes.pojo.util;


import org.quartz.TriggerUtils;
import org.quartz.impl.triggers.CronTriggerImpl;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
/**
 * @Description :CronUtil
 * @Reference :
 * @Author : gsz
 * @CreateDate : 2024-05-10 16:08
 * @Modify:
 **/
public class CronUtil {



    public static String getRecentTriggerTime(String cron) {
        String newTime = "";
        try {
            CronTriggerImpl cronTriggerImpl = new CronTriggerImpl();
            cronTriggerImpl.setCronExpression(cron);
            //下次执行时间 增加一秒
            Date cronTime = new Date();
            cronTime.setTime(new Date().getTime()+1000);
            cronTriggerImpl.setStartTime(cronTime);
            // 这个是重点，一行代码搞定
            List<Date> dates = TriggerUtils.computeFireTimes(cronTriggerImpl, null,5 );
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            newTime = dateFormat.format(dates.get(0));

        } catch (ParseException e) {
            e.printStackTrace();
        }
        return newTime;
    }

}